# -*- coding: utf-8 -*-

import datetime

from django.db import models


class Person(models.Model):
    """
    Физ.лицо
    """
    name = models.CharField(max_length=20, verbose_name=u'Имя')
    surname = models.CharField(max_length=20, verbose_name=u'Фамилия')
    middle_name = models.CharField(
        max_length=20, verbose_name=u'Отчество', default=u'', blank=True)
    date_of_birth = models.DateField(verbose_name=u'Дата рождения')

    @property
    def fullname(self):
        return u' '.join((self.surname, self.name, self.middle_name))

    def __unicode__(self):
        def shortened(word):
            return word[0] + u'.' if word else u''
        return u'%s%s%s (%s)' % (
            shortened(self.name), shortened(self.middle_name),
            self.surname, datetime.datetime.strftime(
                self.date_of_birth, '%d.%m.%Y'
            )
        )

    class Meta:
        verbose_name = u'Физ.лицо'
        verbose_name_plural = u'Физ.лица'
